function loadJSON() {
    clearDebug();

    var jsonstring = window.prompt("Paste JSON string here");

    var graph = JSON.parse(jsonstring);

    return postProcess(graph);
}

function postProcess(graph) {

    var cnt = 0;

    for (var i = 0; i < graph.nodes.length; i++) {
        graph.nodes[i].degree = 0;
        graph.nodes[i].links = [];
        graph.nodes[i].index = graph.nodes[i].id;

        cnt++;
    }

    var cntlinks = 0;

    for (var j = 0; j < graph.links.length; j++) {
        var link = graph.links[j];

        link.index = j;

        // replace indices by references to node
        link.source = graph.nodes[link.source];
        link.target = graph.nodes[link.target];

        link.source.links.push(link);
        link.target.links.push(link);

        link.source.degree++;
        link.target.degree++;

        cntlinks++;
    }

    addDebug('Graph')
    addDebug('  nodes: ' + cnt);
    addDebug('  links: ' + cntlinks);

    markPaths(graph);

    return graph;
}

function removeRandom(arr) {
    var index = Math.floor(Math.random() * arr.length);
    var elt = arr[index];
    arr.splice(index, 1);
    return elt;
}