function shuffle(a) {
    var j, x, i;
    for (i = a.length; i; i--) {
        j = Math.floor(Math.random() * i);
        x = a[i - 1];
        a[i - 1] = a[j];
        a[j] = x;
    }
}

function detectAesthetic(svg,rect,ranknumber,ranking,max_ranking) {
    if (ranking === 0) {
        max_ranking++;
        return [rank(svg,rect,ranknumber,ranking,max_ranking),max_ranking];
    } else if (ranking === max_ranking) {
        max_ranking--;
        return [rank(svg, rect, ranknumber, ranking, 0),max_ranking];
    } else {
        return [ranking,max_ranking];
    }
}

function rank(svg,rect,ranknumber,ranking,rank) {
    rect.attr("class","rank"+rank);
    var fontsize = 350;
    svg.select("#links")
        .selectAll(".linkHalo"+ranking)
        .attr("class","linkHalo"+rank);
    ranknumber.selectAll("text").remove();
    if (rank>0) {
        ranknumber.append("text")
            .text(""+rank)
            .attr("class","ranktext")
            .attr("id","rank"+rank+"text")
            .style("font-size", fontsize+"px")
            .attr("dx", (350/2)+"px")
            .attr("dy", (350*0.84)+"px")
            .attr("text-anchor", "middle")
            .attr("unselectable", "on")
    }
    return rank;
}